
#include <utility/tagitem.h>

/* This part is for all interface functions */

__asm struct AMIS_Requester *BuiltRequester(
										register __a0 struct AMIS_ReqDef *reqdef,
										register __a1 struct TagItem *tags);
__asm long _InterClose(register __a0 struct AMIS_Requester *areq);

struct amisProject {
	struct Node	node;
	struct List	reqs;
	char			name[40];
};

/* Next part is for Red-Black Tree functions */

__asm struct RB_Node *RB_NewNode(register __a0 APTR key);
__asm void RB_InsertNode(register __a0 struct RB_Tree *tree, register __a1 struct RB_Node *node);
__asm void RB_Free(register __a0 struct RB_Tree *tree);
__asm struct RB_Node *RB_Search(register __a0 struct RB_Tree *tree, register __a1 APTR key);
__asm BOOL RB_BuiltTree(register __a0 struct RB_Tree *tree, register __a1 APTR key[]);
__asm void RB_Invoke(register __a0 struct RB_Tree *tree, register __a1 void (*func)());

struct RB_Tree {
	struct RB_Node *tree;
	int				(*compare)(APTR key1,APTR key2);
};

struct RB_Node {
	struct RB_Node	*parent;
	char				color;
	char				type;
	WORD				key_extra;
	struct RB_Node *left;
	struct RB_Node	*right;
	APTR				key;
};

struct RB_Built {
	long				size;
	struct RB_Node	rb_node;
};

#define RED 0
#define BLACK 1

#define RB_NODE_LIST		0
#define RB_NODE_SINGLE	1
#define RB_NODE_FREE		2

#define DEFAULT_SCREEN	1

#define IFLG_BUILD		1
